:-use_module(library(jpl)).

:- category(properties).


:- public(set_property/2).
    :- mode(set_property(+nonvar, +nonvar), one).

    :- public(get_property/2).
    :- mode(get_property(?nonvar, ?nonvar), zero_or_more).

    :- public(del_property/2).
    :- mode(del_property(?nonvar, ?nonvar), zero_or_more).

    :- public(del_properties/2).
    :- mode(del_property(@term, @term), one).

    :- private(property_/2).
    :- mode(property_(?nonvar, ?nonvar), zero_or_more).
    :- dynamic(property_/2).

    set_property(Property, Value):-
        write('Property test : ' + OldValue),nl,
        ::retractall(property_(Property, OldValue)),

        ::assertz(property_(Property, Value)),
        ::firePropertyChange(Property, OldValue,  Value).

    get_property(Property, Value):-
        ::property_(Property, Value),
	write(Value).

    del_property(Property, Value):-
        ::retract(property_(Property, Value)).

    del_properties(Property, Value):-
        ::retractall(property_(Property, Value)).

:- end_category.
