package com.sun.example.mvc.controller;

import java.awt.Font;
import java.beans.PropertyChangeEvent;
import java.util.Hashtable;
import com.sun.example.mvc.model.AbstractModel;
import com.sun.example.mvc.view.DisplayViewPanel;

import jpl.*;

public class LogTalkControler extends AbstractController {

	public LogTalkControler() {
		//Logtalk configuration
		JPL.setDefaultInitArgs(
				new String[] {
						"pl",
						"-f", "none",
						"-g", "set_prolog_flag(debug_on_error,false)",
						"-q",
						"-nosignals" 
				}
				);
		
		//loading logtalk compiler
		Query loadLogtalk = new Query("['lib/logtalkLoad.pl'].");
		if(loadLogtalk.hasSolution())
		{
			System.out.println("Logtalk loaded succesfully");
		}
		else
		{
			throw new RuntimeException("Unable to load logtalk");
		}
		
		Query loadAttributes = new Query("logtalk_load",
				 new Term[] {new Atom("src/com/sun/example/mvc/model/properties")}
				);
		
		if (loadAttributes.hasSolution()) {
			System.out.println("properties loaded succesfully");
		} else {
			throw new RuntimeException("Unable to load properties");
		}
		
		Query loadDocumentModel = new Query("logtalk_load",
				new Term[]{new Atom("src/com/sun/example/mvc/model/documentModel")}
				);
		
		if(loadDocumentModel.hasSolution())
		{
			System.out.println("DocumentModel loaded succesfully");
		}
		else
		{
			throw new RuntimeException("Unable to load DocumentModel");
		}
		
		Query textElementModel = new Query("logtalk_load",
				new Term[]{new Atom("src/com/sun/example/mvc/model/textElementModel")}
				);
		
		if(textElementModel.hasSolution())
		{
			System.out.println("textElementModel loaded succesfully");
		}
		else
		{
			throw new RuntimeException("Unable to load textElementModel");
		}
		//this.setModelProperty("ControlerReference", this);
	}
	private boolean isDocumentModel = true; 
	
	/* (non-Javadoc)
	 * @see com.sun.example.mvc.controller.AbstractController#setModelProperty(java.lang.String, java.lang.Object)
	 */
	@Override
	protected void setModelProperty(String propertyName, Object newValue) 
	{
	

		
		Query setLogtalkProperty  = null;
		Query getLogtalkProp = null;
		if (this.isDocumentModel) {
			setLogtalkProperty 
			//= new Query("documentModel::set_property('"+propertyName + "', jpl_new('java.lang.String',['" + newValue.toString() + "'], _)).");
			= new Query("documentModel::set_property('"+propertyName + "', '" + newValue.toString() + "').");
			
			getLogtalkProp = new Query(
					"documentModel::get_property('" + propertyName + "', X).");
		}else {
			setLogtalkProperty = new Query("textElementModel::set_property('"+propertyName + "', '" + newValue.toString() + "').");
			
			getLogtalkProp = new Query(
					"textElementModel::get_property('" + propertyName + "', X).");
		}
		
		
		if(setLogtalkProperty.hasSolution())
		{
		}
		else
		{
			throw new RuntimeException("Unable to set property named : " + propertyName );
		}
		
		Variable X = new Variable("X");
		
		
		if(getLogtalkProp.hasMoreElements())
		{
			Object elem = getLogtalkProp.nextElement();
			if (elem instanceof Hashtable) {
				Hashtable<String, Atom> solution = (Hashtable<String, Atom>) elem;
				
				System.out.println("Solution is " + solution.get("X"));

				
			
					Atom atomVal = (Atom)solution.get("X");
					String strValue = atomVal.name(); 
					Object value = strValue;
					try {
						value = java.lang.Integer.valueOf( strValue).intValue();
					} catch (Exception e) {
						// TODO: handle exception
					}
					
					DisplayViewPanel displayView = (DisplayViewPanel) this.registeredViews.get(0);
					PropertyChangeEvent event = new PropertyChangeEvent(this, propertyName, newValue, value);
					displayView.modelPropertyChange(event);
				
			}
		}
	}
   //  Properties this controller expects to be stored in one or more registered models
    
    /**
     * The document's name
     */
    public static final String DOCUMENT_NAME_PROPERTY = "Name";
    /**
     * The document's width
     */
    public static final String DOCUMENT_WIDTH_PROPERTY = "Width";
    /**
     * The document's height
     */
    public static final String DOCUMENT_HEIGHT_PROPERTY = "Height";    
    /**
     * The text element's string
     */
    public static final String ELEMENT_TEXT_PROPERTY = "Text";
    /**
     * The text element's font
     */
    public static final String ELEMENT_FONT_PROPERTY = "Font";
    /**
     * The text element's X position
     */
    public static final String ELEMENT_X_PROPERTY = "X";
    /**
     * The text element's Y position
     */
    public static final String ELEMENT_Y_PROPERTY = "Y";
    /**
     * The text element's opacity
     */
    public static final String ELEMENT_OPACITY_PROPERTY = "Opacity";
    /**
     * The text element's rotation
     */
    public static final String ELEMENT_ROTATION_PROPERTY = "Rotation";
    
    /**
     * Change the document name in the model
     * @param newName The new document name
     */
    public void changeDocumentName(String newName) {
    	this.isDocumentModel = true;
        setModelProperty(DOCUMENT_NAME_PROPERTY, newName);                                 
    }
    
    /**
     * Change the document width in the model
     * @param newWidth The new document width
     */
    public void changeDocumentWidth(int newWidth) {
    	this.isDocumentModel = true;
        setModelProperty(DOCUMENT_WIDTH_PROPERTY, newWidth);                                 
    }
    
    /**
     * Change the document height in the model
     * @param newHeight The new document height
     */
    public void changeDocumentHeight(int newHeight) {
    	this.isDocumentModel = true;
        setModelProperty(DOCUMENT_HEIGHT_PROPERTY, newHeight);                         
    }
    
    
    /**
     * Change the text element string in the model
     * @param newText The new text element string
     */
    public void changeElementText(String newText) {
    	this.isDocumentModel = false;
        setModelProperty(ELEMENT_TEXT_PROPERTY, newText);                 
    }
    
    /**
     * Change the text element font in the model
     * @param newFont The new text element font
     */
    public void changeElementFont(Font newFont) {
    	this.isDocumentModel = false;
        setModelProperty(ELEMENT_FONT_PROPERTY, newFont);
    }
    
    /**
     * Change the text element X position value in the model
     * @param newX The new text element X position
     */
    public void changeElementXPosition(int newX) {
    	this.isDocumentModel = false;
        setModelProperty(ELEMENT_X_PROPERTY, newX);         
    }
    
    /**
     * Change the text element Y position value in the model
     * @param newY The new text element Y position
     */
    public void changeElementYPosition(int newY) {
    	this.isDocumentModel = false;
        setModelProperty(ELEMENT_Y_PROPERTY, newY);        
    }
    
    /**
     * Change the text element opacity value in the model
     * @param newOpacity The new text element opacity value
     */
    public void changeElementOpacity(int newOpacity) {
    	this.isDocumentModel = false;
        setModelProperty(ELEMENT_OPACITY_PROPERTY, newOpacity);
    }
    
    /**
     * Change the text element rotation value in the model
     * @param newRotation The new text element rotation value
     */
    public void changeElementRotation(int newRotation) {
    	this.isDocumentModel = false;
        setModelProperty(ELEMENT_ROTATION_PROPERTY, newRotation);        
    }
}
